function [out]=bprb_thinplate(in, K)
% function [out]=bprb_thinplate(in, K) calculates size(K,1) output activations 
% (columns in out) from each input (in) with each kernel (K). out has
% size(K,1) columns and size(in,1) rows. the number of columns in in and
% K must be identical.
%
% P. Sykacek, July 1999-2006
%# scalar nrin i nK

nrin=size(in,1);
nK=size(K,1);
out=zeros(nrin, nK);
i=1;
while i<=nK
  dist=[in-K(i*ones(nrin,1),:)]';
  dist=sum(dist.*dist,1)';
 % whos
  out(:,i)=dist+eps; % prevent log of zeros
  lgout=log(out(:,i));
  % lgout(find(isinf(lgout)))=0;
  out(:,i)=out(:,i).*out(:,i).*lgout;
  i=i+1;
end
